2014-04-27 07:17 PM - Etienne Tourigny

Status: Open

Priority: Normal

Assignee:

Category: Data Provider/OGR

Pull Request or Patch supplied: Resolution:

Easy fix?: No Copied to github as #: 18586
Description

More details on vsipreload and why it would be a good thing to have it inside QGIS

http://0sgeo-org.1560.x6.nabble.com/gdal-dev-vsipreload-enabling-VSI-Virtual-File-API-for-reqular-I-O-td505581 1 .html

From gdal NEWS:

Add vsipreload.cpp that can be compiled as a shared library that can be LD_PRELOAD'ed as an overload of libc to enable VSI Virtual
FILE API to be used with binaries using regular libc for I/0

Many formats (e.g. netcdf) cannot be read inside .zip files without this

basically, it could be implemented this way (at least in linux):

- create a shared lib vsipreload.so and install it with other qgis libs (e.g. /usr/lib/)

this is how it is done inside gdal, should be done in another manner in qgis
g++ -Wall -fPIC port/vsipreload.cpp -shared -o vsipreload.so -Iport -L. -L.libs -lIgdal

- modify qgis startup script so that qgis is started like this

LD_PRELOAD-=vsipreload.so qgis.bin

| am not sure about licensing issues though, can we copy the port/vsipreload.cpp to qgis source legally? Looks ok to me.

History

#1 - 2014-05-07 07:09 PM - Etienne Tourigny
- File vsipreload-patch.txt added
- File vsipreload.cpp added

Attaching the vsipreload.cpp code and a patch that allows to build and install it as a shared library.

With this, ggis can be started using the LE_ PRELOAD trick. It sould be easy to add this to the debian builds, which already use a startup script.

#2 - 2014-05-07 10:33 PM - Paolo Cavallini

A pull request is probably better.
#3 - 2014-05-08 04:10 PM - Etienne Tourigny
- File landsat-gz.nc.gz added

#4 - 2014-05-08 04:13 PM - Etienne Tourigny

added a pull request, this works with debian build

https://github.com/qgis/QGIS/pull/1342

#5 - 2016-05-24 01:06 PM - Alexander Bruy
- Category changed from Build/Install to Data Provider/OGR

#6 - 2017-05-01 12:47 AM - Giovanni Manghi
- Easy fix? set to No

Files

vsipreload-patch.ixt 1.08 KB 2014-05-07 Etienne Tourigny

vsipreload.cpp 55.1 KB 2014-05-07 Etienne Tourigny

landsat-gz.nc.gz 29.4 KB 2014-05-08 Etienne Tourigny
